/*
 *
 *                 SUNIX Matrix Series Board Port Information Dump Program
 *
 *
 *
 *                                                              Version: 1.00
 *                                                              Date: 2007/01/31
 */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <fcntl.h>
#include <asm/ioctls.h>
#include "../driver/sunix_matrix.h"

char p_name[11] = "/dev/ttySMX";

int main(void)
{
	int fd, port_count = 0;
	struct port_info dump_port_info[MATRIX_UART_TOTAL_MAX];


	char port_name[15];

	int  i;
	unsigned char quotient;
	unsigned char remainder;

	memset(dump_port_info, 0, (sizeof(struct port_info) * MATRIX_UART_TOTAL_MAX));


	for (i = 0 ; i < MATRIX_UART_TOTAL_MAX ; i++)
	{
		if (i < 10)
		{
			memset(port_name, 0, sizeof(port_name));
			remainder = toascii(i + 176);

			strcpy(port_name, p_name);
			strncat(port_name, &remainder, 1);

			fd = open(port_name, O_RDWR | O_NOCTTY);

			if (fd > 0)
			{
				ioctl(fd, SUNIX_DUMP_PORT_INFO, &dump_port_info[i]);
				close(fd);
				port_count++;
			}
			else
			{
				dump_port_info[i].base_info = 0;
			}
		}
		else
		{
			memset(port_name, 0, sizeof(port_name));
			quotient = toascii( (i / 10) + 176);
			remainder = toascii( (i % 10) + 176);

			strcpy(port_name, p_name);
			strncat(port_name, &quotient, 1);
			strncat(port_name, &remainder, 1);

			fd = open(port_name, O_RDWR | O_NOCTTY);

			if (fd > 0)
			{
				ioctl(fd, SUNIX_DUMP_PORT_INFO, &dump_port_info[i]);
				close(fd);
				port_count++;
			}
			else
			{
				dump_port_info[i].base_info = 0;
			}
		}
	}


	system("clear");

	if (port_count > 0)
	{
		printf("\n================ Found %2d SUNIX port, list informations below ===============\n\n",port_count);
		for(i = 0; i < MATRIX_UART_TOTAL_MAX; i++)
		{
			if(!(dump_port_info[i].base_info))
			{
				continue;
			}

			printf("ttySMX%d --\n",dump_port_info[i].port_info);
			printf("%s (bus:%d device:%2d) , base address = %4x, irq = %2d\n\n",
					dump_port_info[i].function_name_info,
 					dump_port_info[i].bus_number_info,
 					dump_port_info[i].dev_number_info,
 					dump_port_info[i].base_info,
 					dump_port_info[i].irq_info
					);
		}
	}
	else
	{
		printf("\n=========== No SUNIX port been found, type 'lsmod' to check driver ==========\n\n",port_count);
	}

	printf("=============================================================================\n");
 	return(0);
}
